local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
local f = CreateFrame('GameTooltip', 'MyTooltip', UIParent, 'GameTooltipTemplate'); -- we load our own tooltip frame
WoWRGP={};
local UnitPower={"Rage","Focus","Energy","Happiness","Runes","RunicPower"};UnitPower[0]="Mana";
local UnitSlots={"Head","Neck","Shoulder","Shirt","Chest","Waist","Legs","Feet","Wrist","Hands","Finger0","Finger1","Trinket0","Trinket1","Back","MainHand","SecondaryHand","Ranged","Tabard"};
local UnitStatName={"Strength","Agility","Stamina","Intellect","Spirit"};
local UnitSchoolName={"Physical","Holy","Fire","Nature","Frost","Shadow","Arcane"};
local UnitResistanceName={"Holy","Fire","Nature","Frost","Shadow","Arcane"};
if(not frame.colorTitle) then frame.colorTitle="909090"; end
if(not frame.colorGreen) then frame.colorGreen="00cc00"; end
if(not frame.colorRed)   then frame.colorRed  ="ff0000"; end

local wowrpref={
		["enabled"]=true,
		["verbose"]=false,
		["reagentfull"]=true,
		["talentsfull"]=true,
		["questsfull"]=false,
		["debug"]=false,
		["ver"]=031000,
		["scan"]={
			["inventory"]=true,
			["currency"]=true,
			["talents"]=true,
			["honor"]=true,
			["reputation"]=true,
			["spells"]=true,
			["pet"]=true,
			["companions"]=true,
			["equipment"]=true,
			["mail"]=true,
			["professions"]=true,
			["quests"]=true,
			["bank"]=true,
			["glyphs"]=true,
			["dstalents"] = true,
			["dsglyphs"] = true,
			["dsspells"] = true,
		},
		["guild"]={
			["compact"]=true,
			["title"]=true,
			["vault"]=true,
			["vault_log"]=true,
			["vault_money"]=true,
			["trades"]=true,
		},
};

frame.class = {WARRIOR=1,PALADIN=2,HUNTER=3,ROGUE=4,PRIEST=5,DEATHKNIGHT=6,SHAMAN=7,MAGE=8,WARLOCK=9,DRUID=11};
frame.race = {Human=1,Orc=2,Dwarf=3,NightElf=4,Scourge=5,Tauren=6,Gnome=7,Troll=8,BloodElf=10,Draenei=11,Worgen=22};
frame.tooltip = "wowrcptooltip";


local function findPanel(name, parent)
	for i, button in next, InterfaceOptionsFrameAddOns.buttons do
		if button.element then
			if name and button.element.name == name then return button
			elseif parent and button.element.parent == parent then return button
			end
		end
	end
end

function frame:ButtonHandler()
	self.buttons = {}
	local button = CreateFrame("Button", "GuildProfilerbtm", GuildFrame, "UIPanelButtonTemplate");
	button.tooltip = "Save guild data"--L["Click to export your Guild Profile!"]
	button.startTooltip = button.tooltip
	button:SetPoint("TOPRIGHT", GuildFrame, "TOPRIGHT", -25, 0)
	button:SetWidth(50)
	button:SetHeight(18)
	button:SetText("Save") --L["save"])
	button:SetScript("OnEnter", showTooltip)
	button:SetScript("OnLeave", hideTooltip)
	button:SetScript("OnClick", function(self)frame:gpexport()end )
	self.buttons.save = button
end

--[UnitClass] arg1:unit
frame.UnitSex = function(arg1)
	local UnitSexLabel={UNKNOWN,MALE,FEMALE};
	local unitSexID=UnitSex(arg1);
	return UnitSexLabel[unitSexID],mod(unitSexID,2);
end

--[UnitClass] arg1:unit
frame.UnitClass = function(arg1)
	local unitClass,unitClassEn=UnitClass(arg1);
	return unitClass,unitClassEn,frame.class[unitClassEn];
end

--[UnitClassID] arg1:unit
frame.UnitClassID = function(classEn)
	return frame.class[classEn];
end

--[UnitRace] arg1:unit
frame.UnitRace = function(arg1)
	local unitRace,unitRaceEn=UnitRace(arg1);
	return unitRace,unitRaceEn,frame.race[unitRaceEn];
end
local Guild_name = GetGuildInfo("player");
local Server = GetRealmName();
local stat = {
	_server=GetRealmName(),
	_player=UnitName("player"),
	_guild=GetGuildInfo("player"),
	_officer=CanViewOfficerNote(),
	_guilded=IsInGuild(),
	_guildInfo=nil,
	_loaded,
	_time,
	_guildNum,
	Vault={},
	Vaultavl=true,
};

frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
frame:RegisterEvent("Blizzard_GuildUI");
frame:RegisterEvent("GUILDBANKFRAME_OPENED"); 
function frame:OnEvent(event, arg1)

	if event == "ADDON_LOADED" and arg1 == "wowrgp" then
		frame:Print('WoWR-GP '.. WoWRCP.gpVersion..' Loaded');
		if ( IsAddOnLoaded("wowrcp") ) then
			frame:Print("WoWR-CP is loaded");
			frame:startup();
		else
			frame:Print(frame.StringColorize(frame.colorRed,"WoWr-CP missing or not loaded disableing WoWR-GP"));
			DisableAddOn("wowrgp")			
		end
	elseif arg1 == "Blizzard_GuildUI" then
		frame:ButtonHandler();
	elseif event == "GUILDBANKFRAME_OPENED" then
		frame:GUILDBANKFRAME_OPENED();
	end
end

function frame:startup()

	Guild_name = GetGuildInfo("player");
	Server = GetRealmName();
	
	frame:ButtonHandler();
	frame:InitState();
	frame:InitProfile();
	
	if (not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]) then
		--cpProfile = 0; -- This is the first time this addon is loaded; initialize the count to 0.
		frame:Print("Welcome, <".. GetGuildInfo("player") .."> preparing your WoWR-GP profile!");
	elseif (WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]) then
		frame:Print("Welcome, <".. GetGuildInfo("player") .."> loading your WoWR-GP profile!");
	else
		--cpProfile = cpProfile + 1; -- It's a new character.
		frame:Print("some damn error...");
	end
end

function WoWRGP:intGP()
	frame:startup();
end
frame:SetScript("OnEvent", frame.OnEvent);
SLASH_WOWRGP1 = "/wrg";
function SlashCmdList.WOWRGP(msg)
 if msg == 'test' then
	DEFAULT_CHAT_FRAME:AddMessage('This is a test'.. WoWRCP.Version ..'');
	--frame:GetBank();
	
 else
	DEFAULT_CHAT_FRAME:AddMessage('WoWR-CP 2.2.2 MoP Edition');
 end
end

function frame:gpexport()
	frame:UpdateDate();
	frame:ScanGuildMembers();
	frame:UpdateDate();
	frame:ScanGuildControl();
	frame:ScanGuildEventLog();
	--frame:Scannews();
	--frame:ScanGuildControl();
	--frame:ScanGuildEventLog()
	msg = stat["_guild"];
	print(msg);
	msg = "Vault:";
	tsort={};
	table.foreach(stat["Vault"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your guild vault to scan";
		else
		for _,item in pairs(tsort) do
			msg=msg .. " " .. item.."-"..stat["Vault"][item]["inv"].."/"..stat["Vault"][item]["slot"];
		end
	end

	print(msg);
	msg = "Members: "..stat["_guildNum"].." ";
	print(msg);
end 

function frame:InitState()
	Guild_name = GetGuildInfo("player");
	Server = GetRealmName();

	stat={
		_server=GetRealmName(),
		_player=UnitName("player"),
		_guild=GetGuildInfo("player"),
		_officer=CanViewOfficerNote(),
		_guilded=IsInGuild(),
		_guildInfo=nil,
		_loaded,
		_time,
		_guildNum,
		Vault={},
		Vaultavl=false,
	};
end

function frame:InitProfile()
	
	strctx= {};
	
	if ( not(Guild_name) ) then
		Guild_name = GetGuildInfo("player");
	end

	if( not WoWRCP.db[stat["_server"]]["Guild"] ) then
		WoWRCP.db[stat["_server"]]["Guild"]={}; 
	end
	if( not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]] ) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]={}; 
		frame:Print('Guild Profile for '.. stat["_guild"] ..' Created');
	else
		frame:Print('Guild Profile for '.. stat["_guild"] ..' Loaded');
	end


	local currentXP, remainingXP = UnitGetGuildXP("player");
	local nextLevelXP = currentXP + remainingXP;

		strctx["GPversion"]		= "2.1.0";
		strctx["CPprovider"]	= "wowr";
		strctx["DBversion"]		= "5.0.3";
		strctx["GuildName"]		= stat["_guild"];
		strctx["Server"]		= stat["_server"];
		strctx["Locale"]		= GetLocale();
		strctx["GuildXP"]		= currentXP..":"..nextLevelXP;
		--WoWRCP.db["GuildXPCap"]	= dailyXP..":"..maxDailyXP;
		strctx["GuildLevel"]	= GetGuildLevel();
		strctx["FactionEn"],
		strctx["Faction"]		=UnitFactionGroup("player");
		strctx["timestamp"] 	= {};
		strctx["Motd"] 			= GetGuildRosterMOTD();
		frame:UpdateDate();
		stat["_loaded"] = true;
		
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]] = strctx;
	
	return stat["_loaded"];
end

function frame:ScanGuildEventLog()
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["EventLog"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["EventLog"]={};
	end
	local db = WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["EventLog"];
	local type, player1, player2, rank, year, month, day, hour;
	local numEvents = GetNumGuildEvents();
	local time=time();

--RPGOGP:PrintDebug("EventLog",numEvents,table.getn(db));
	if(numEvents >= table.getn(db)) then
		for idx=1, numEvents, 1 do
			type, player1, player2, rank, year, month, day, hour = GetGuildEventInfo(idx);
			if ( not player1 ) then
				player1 = UNKNOWN;
			end
			if ( not player2 ) then
				player2 = UNKNOWN;
			end
			db[idx] = {
				Type	= type,
				Player1	= player1,
				Player2	= player2,
				Rank	= rank,
				Time	= time,
				LogTime	= strjoin(":",year, month, day, hour),
			};
		end
	else
		QueryGuildEventLog();
	end
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["EventLog"] = db;
end



function frame:UpdateDate()
	if(not WoWRCP.db) then return; end;

	struct={};
	if ( not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["timestamp"] ) then 
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["timestamp"]={};
	end;
	
	local timestamp = time();
	local currHour,currMinute=GetGameTime();
	--struct["timestamp"]={};
	struct["init"]={};
	struct["init"]["TimeStamp"]=timestamp;
	struct["init"]["Date"]=date("%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["DateUTC"]=date("!%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["ServerTime"]=format("%02d:%02d",currHour,currMinute);
	struct["init"]["datakey"]=frame.versionkey();
	
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["timestamp"] = struct;
end

function frame:GetGuildInfo()
	if( not IsInGuild() ) then
		stat["_guilded"]=false;
		return;
	end
	strict = {};
	Guild_name = GetGuildInfo("player");
	local numGuildMembers, onlineMembers = GetNumGuildMembers();

	QueryGuildEventLog();
	local currentXP, remainingXP = UnitGetGuildXP("player");
	local nextLevelXP = currentXP + remainingXP;
	
	stat["_guilded"]=true;
	strict["Info"] = GetGuildInfoText();
	strict["FactionEn"],strict["Faction"] = UnitFactionGroup("player");
	strict["GPversion"]		= "1.2.0";
	strict["CPprovider"]	= "wowr";
	strict["DBversion"]		= "3.1";
	strict["GuildName"]		= stat["_guild"];
	strict["Server"]		= stat["_server"];
	strict["Locale"]		= GetLocale();
	strict["GuildXP"]		= currentXP..":"..nextLevelXP;
	strict["GuildLevel"]	= GetGuildLevel();
	strict["Motd"] 			= GetGuildRosterMOTD();
	
	if(numGuildMembers~=0) then
		strict["NumMembers"]=numGuildMembers;
		frame:ScanGuildMembers(numGuildMembers);
		stat["_guildNum"]=numGuildMembers;
	end
	frame:ScanGuildMOTD();
	strict["ScanInfo"] = {
		Character = stat["_player"],
		IsGuildLeader = (IsGuildLeader()==1 or false),
		HasOfficerNote = (stat["_officer"]==1 or false)
	};
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]] = strict;
end
function frame:ScanGuildMOTD()
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]] = GetGuildRosterMOTD();
end

function frame:ScanGuildMembers(numMembers)
	stat["_officer"] = CanViewOfficerNote();
	if ( not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Members"] ) then WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Members"]={}; end;
	DEFAULT_CHAT_FRAME:AddMessage('save members list');
	--if(numMembers > 0 and (stat["_guildNum"]~=numMembers)) then
	local numMembers, onlineMembers = GetNumGuildMembers();
	local showOfflineTemp=GetGuildRosterShowOffline();
	SetGuildRosterShowOffline(true);
	local cnt = 0;
	local guildMemberTemp={};
	for idx=1,numMembers do
		local name,rank,rankIndex,level,class,zone,note,officernote,online,status,classEn,achievementPoints,achievementRank,isMobile=GetGuildRosterInfo(idx);
		local lastonline;
		if(name~=nil)then
			if(stat["_officer"]) then
			elseif((guildMemberTemp) and guildMemberTemp[name]) then
				officernote = guildMemberTemp[name]["OfficerNote"];
			end

			-- ################### now hardcode but can be used rankindex and setup in options!
			if (rank=="Alter" or rank=="Alter de Ofi") then
				local correct = string.find(note,"ALT-");
				local main = string.sub(note, 5);
				if (correct == nil) then
					--frame:Print(string.format(L["Note: Revise public note for %s (%s) = '%s' should start with 'ALT-'."],name,rank,note));
				elseif ( not UnitIsInMyGuild(main)) then
					--frame:Print(string.format(L["Note: Revise public note for %s (%s) = '%s' because %s is not in the guild."],name,rank,note,main));
				end
			end
			-- ##################

			if(not wowrpref["guild"]["title"]) then rank = nil; end

			if(wowrpref["guild"]["compact"]) then
				if(status=="") then status = nil; end
				if(note=="") then note = nil; end
				if(officernote=="") then officernote = nil; end
			end
			if(not online) then
				lastonline = strjoin(":",GetGuildRosterLastOnline(idx));
			end
			
			guildMemberTemp[name] = {
				Name	= name,
				Rank	= rankIndex,
				RankEn	= rank,
				Title	= rank,
				Level	= level,
				Class	= class,
				ClassId	= frame.UnitClassID(classEn),
				Zone	  = zone,
				Status	= status,
				Note	  = note,
				OfficerNote= officernote,
				Online	   = online,
				LastOnline = lastonline,
				AchPoints = achievementPoints,
				AchRank = achievementRank,
				Mobile = isMobile,
			};

			local weeklyXP, totalXP, weeklyRank, totalRank = GetGuildRosterContribution(idx);
			if weeklyXP then
				guildMemberTemp[name]["XP"] = {};
				guildMemberTemp[name]["XP"] = {
					WeeklyXP = weeklyXP,
					TotalXP = totalXP,
					WeeklyRank = weeklyRank,
					TotalRank = totalRank,
				};
			end
			cnt=cnt+1;
		end
	end

	SetGuildRosterShowOffline(showOfflineTemp);
	if(numMembers==tablelength(guildMemberTemp)) then
		stat["_guildNum"] = cnt;
		if(stat["_guildInfo"]~=numMembers) then
			GuildInfo();
			stat["_guildInfo"]=numMembers;
		end
		--WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Members"]=guildMemberTemp;
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Members"]=guildMemberTemp;
	end
end



function frame:ScanGuildControl()
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Control"]={};

	for idx=1,GuildControlGetRankFlagsNum(GuildControlGetRankFlags()) do
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Control"][idx]=getglobal("GUILDCONTROL_OPTION"..idx);
	end
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Ranks"]={};
	for idx=1,GuildControlGetNumRanks() do
		GuildControlSetRank(idx);
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Ranks"][idx-1]={
			Title=GuildControlGetRankName(idx),
			Control=self:GuildControlGetRankFlagsStr(GuildControlGetRankFlags()),
			--Withdraw= GetGuildBankTabPermissions(currentTab) (),
		};
		local numTabs = GetNumGuildBankTabs();
		for i=1, MAX_GUILDBANK_TABS do
			if ( i <= numTabs ) then
				local viewTab, canDeposit, updatetext, numWithdrawals = GetGuildBankTabPermissions(i);
				viewTab = viewTab or 0;
				canDeposit = canDeposit or 0;
				numWithdrawals = numWithdrawals or 0;
				WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Ranks"][idx-1]["Tab"..i]=strjoin(":",viewTab, canDeposit, numWithdrawals);
			else
				WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Ranks"][idx-1]["Tab"..i]=nil;
			end
		end
	end
end

function GuildControlGetRankFlagsNum(...)
	return select("#",...);
end


--[[
function frame:GUILDBANKFRAME_OPENED()
	if(wowrpref["guild"]["vault"]) then
		numTabs = GetNumGuildBankTabs();
		for tab=1, numTabs do
			QueryGuildBankTab(tab);
		end
		frame:ScanGuildBank();
	end
end
]]--
function frame:GUILDBANKBAGSLOTS_CHANGED()
	stat["Vaultavl"] = false;
	frame:ScanGuildBank();
end

function frame.ScanGuildBankQueue()
	local queue = frame.queue;
	if(not queue or table.getn(queue) == 0) then return end;
	for idx,tab in pairs( queue ) do
		if( tab[1] == "GUILDBANKBAGSLOTS_CHANGED" ) then
			QueryGuildBankTab(tab[3]);
		elseif( tab[1] == "GUILDBANKLOG_UPDATE" ) then
			QueryGuildBankLog(tab[3]);
		end
	end
end

function frame:GUILDBANKFRAME_OPENED()
	if(not wowrpref["guild"]["vault"]) then
		return nil;
	end
	numTabs = GetNumGuildBankTabs();
		for tab=1, numTabs do
			QueryGuildBankTab(tab);
		end
	
print("Hello, " .. stat["_server"] .." - ".. stat["_guild"] .. " Pre-scanning of your profile has started!");
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]={};
	end
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]={};
	end
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]={};
	end
	stat["Vault"] = {};
	numTabs = GetNumGuildBankTabs()
	local isViewable
	for tab=1, numTabs do
		if ( stat["Vaultavl"]) then
			QueryGuildBankTab(tab);
		end
		_,_,isViewable = GetGuildBankTabInfo(tab);

		if( isViewable ) then
			stat["Vault"]["Tab"..tab]={};
			frame.ScanGuildBankTab(tab);
		else
			WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]=nil;
			WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Tab"..tab]=nil;
		end
	end
	if(wowrpref["guild"]["vault_money"]) then
		frame:ScanGuildBankMoney()
	end
	frame:Print("Guild vault scaned");
end

function frame.ScanGuildBankTab(tab)
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]={};
	end
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]["Contents"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]["Contents"]={};
	end

	local gbank = WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab];
	local tabName,tabIcon  = GetGuildBankTabInfo(tab);

	gbank["Name"] = tabName;
	gbank["Icon"] = frame.scanIcon(tabIcon);
	local itemLink;
	local itemIcon, itemCount;
	local bagInv = 0;
	for idx=1, MAX_GUILDBANK_SLOTS_PER_TAB do
		itemIcon, itemCount,_ = GetGuildBankItemInfo(tab,idx);
		itemLink = GetGuildBankItemLink(tab,idx)
		if(itemLink) then
			bagInv=bagInv+1;
		end
		gbank["Contents"][idx] = frame:ScanItemInfo(itemLink,itemIcon,itemCount,idx,tab);
	end
	
	if(wowrpref["guild"]["vault_log"]) then
		frame.ScanGuildBankTabLog(tab)
	end
	local numTransactions = GetNumGuildBankTransactions(tab);

	--WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Tabs"]["Tab"..tab] = gbank;
	--frame:Print("Tab "..tab.." items "..bagInv.." log entrys "..numTransactions.."");
	stat["Vault"]["Tab"..tab]={slot=MAX_GUILDBANK_SLOTS_PER_TAB,inv=bagInv};
end

function frame:ScanItemInfo(itemstr,itemtexture,itemcount,idx,tab)
	local function numNil(num)
		if(wowrpref["fixquantity"] and num and num<=1) then return nil
		else return num
		end
	end
	if(itemstr) then
		local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(itemstr);
		if(not itemName or not itemColor) then
			itemName,itemColor=frame.GetItemInfoTT(self.tooltip);
		end

		GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE'); 
		GameTooltip:SetGuildBankItem(tab,idx);
		tooltip = frame.scantooltip2();
		GameTooltip:Hide();
		local itemBlock={
			Name	= itemName,
			Item	= itemID,
			Color	= frame.scanColor(itemColor),
			Rarity	= itemRarity,
			Quantity= numNil(itemcount),
			Icon	= frame.scanIcon(itemtexture or itemTexture),
			Tooltip	= tooltip,
			Type	= itemType,
			SubType	= itemSubType,
			iLevel	= itemLevel,
			reqLevel= itemReqLevel,
		};
		return itemBlock;
	end

	return nil;
end

function frame.ScanGuildBankTabLog(tab)
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Tab"..tab]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Tab"..tab]={};
	end

	local gbankb = WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Tab"..tab];
	local type, name, itemLink, count, tab1, tab2, year, month, day, hour;
	local itemID
	local numTransactions = GetNumGuildBankTransactions(tab);

	if(numTransactions >= table.getn(gbankb)) then
		for idx=1, numTransactions, 1 do
			type, name, itemLink, count, tab1, tab2, year, month, day, hour = GetGuildBankTransaction(tab,idx);
			_,_,itemID=frame.GetItemInfo(itemLink);
			gbankb[idx] = {
				Type	= type,
				Name	= name or UNKNOWN,
				Tab1	= tab1,
				Tab2	= tab2,
				Item	= itemID,
				Count	= count,
				Time	= strjoin(":",year, month, day, hour)
			};
		end
	else
		QueryGuildBankLog(tab);
	end
end

function frame:ScanGuildBankMoney()
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]={};
	end
	WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Money"] = frame.Arg2Tab("Gold","Silver","Copper",frame.parseMoney(GetGuildBankMoney()));
	QueryGuildBankLog(MAX_GUILDBANK_TABS+1);
	
	if(wowrpref["guild"]["vault_log"]) then
		frame.ScanGuildBankMoneyLog()
	end
end

function frame.ScanGuildBankMoneyLog()
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]={};
	end
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]={};
	end
	if(not WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Money"]) then
		WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Money"]={};
	end
	local gbankdb = WoWRCP.db[stat["_server"]]["Guild"][stat["_guild"]]["Vault"]["Log"]["Money"];
	local type, name, amount, year, month, day, hour;
	local numTransactions = GetNumGuildBankMoneyTransactions();

	if(numTransactions >= table.getn(gbankdb)) then
		for idx=1, numTransactions, 1 do
			type, name, amount, year, month, day, hour = GetGuildBankMoneyTransaction(idx);
			gbankdb[idx] = {
				Type	= type,
				Name	= name or UNKNOWN,
				Amount	= amount,
				Time	= strjoin(":",year, month, day, hour)
			};
		end
	end
end

--[Str2Abbr] str
frame.Str2Abbr = function(str)
	local abbr='';
	local function S2Ahelper(word) abbr=abbr..string.sub(word,1,1) end
	if not string.find(string.gsub(str,"%w+",S2Ahelper),"%S") then return abbr end
end

--[Arg2Tab] arg:key.1,key.n,val.1,val.n
frame.Arg2Tab = function(...)
	local tab={};
	local split=floor( select("#",...) /2);
	for i=1,split do tab[select(i,...)]=select(i+split,...); end
	return tab;
end

--[Arg2Ary] arg:arg.1,arg.n
frame.Arg2Ary = function(...)
	local tab={};
	for i=1,select("#",...) do tab[i]=select(i,...); end
	return tab; 
end
frame.parseMoney = function(money)
	local gold,silver,copper;
	local COPPER_PER_GOLD=COPPER_PER_SILVER * SILVER_PER_GOLD;
	gold=floor(money/COPPER_PER_GOLD);
		money=mod(money,COPPER_PER_GOLD);
	silver=floor(money/COPPER_PER_SILVER);
		copper=mod(money,COPPER_PER_SILVER);
	return gold,silver,copper;
end
frame.scanIcon = function(str)
	if(not str) then return nil; end
	str=string.gsub(str,".BLP","");
	return table.remove({ strsplit("\\", str) });
end
--[GetItemInfo] itemStr
frame.GetItemInfo = function(itemStr)
	if(itemStr) then
		local itemColor,itemID;
		local itemName,itemLink,itemRarity,itemLevel,itemReqLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,invTexture = GetItemInfo(itemStr);
		if(itemLink) then
			_,_,itemColor,itemID=string.find(itemLink,"|c(%x+)|Hitem:([-%d:]+)|h%[.-%]|h");
		end
		return itemColor,itemLink,itemID,itemName,invTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity;
	end
	return nil;
end
frame.scantooltip2 = function()
	local ttName = "GameTooltip";
	local isHTML = true

	if(GameTooltip and GameTooltip:NumLines() > 0) then
		local idx,ttFontStr,tmpbuff,ttText=nil,nil,nil,{};
		for idx=1,GameTooltip:NumLines() do
			tmpbuff=nil;
			ttFontStr=getglobal(ttName.."TextLeft"..idx);
			if(ttFontStr and ttFontStr:IsShown()) then
				tmpbuff=ttFontStr:GetText();
				if (ttFontStr) then
					tmpbuff=string.gsub(tmpbuff,"\n","<br>");
					tmpbuff=string.gsub(tmpbuff,"\r","");
				end
			end
			ttFontStr=getglobal(ttName.."TextRight"..idx);
			if(ttFontStr and ttFontStr:IsShown() and ttFontStr:GetText()) then
				if(tmpbuff) then
					tmpbuff=tmpbuff.."\t"..ttFontStr:GetText();
				else
					tmpbuff=ttFontStr:GetText();
				end
			end
			if(tmpbuff) then table.insert(ttText,tmpbuff); end
		end
		GameTooltip:ClearLines();
		if(isHTML) then
			return table.concat(ttText,"<br>");
		else
			return ttText;
		end
	end
	return "";
end
frame.scanColor = function(str)
	if(not str) then return nil; end
	local _,_,c = string.find(str,"%x%x(%x%x%x%x%x%x)");
	return c
end

function  frame:GuildControlGetRankFlagsStr(...)
	local flags={};
	for i=1,select("#",...) do
		local v=select(i,...);
		v = v or 0;
		table.insert(flags,v);
	end
	return(table.concat(flags,":"));
end

function tablelength(T)
	local count = 0
	for _ in pairs(T) do
		count = count + 1
	end
	return count
end 

frame.version = function()
	local version,_,_ = GetBuildInfo();
	local _,_,version,major,minor=string.find(version,"(%d+).(%d+).(%d+)");
	return tonumber(version),tonumber(major),tonumber(minor);
end
frame.StringColorize = function(color,msg)
	if(color and msg) then
		return "|cff"..color..msg.."|r";
	end
end
frame.versionkey = function()
	local version,buildnum,_ = GetBuildInfo();
	return strjoin(":", frame.GetSystem(),version,buildnum);
end
function frame:Print(...)
	print("|cff33ff99WoWR-GP|r:", ...)
end
--[function] str
frame.GetSystem = function()
	local _,_,sys=string.find(GetCVar("realmList"),"^[%a.]-(%a+).%a+.%a+.%a+$");
	if(not sys) then sys="" end return sys;
end